## schrankwand.py
from leinwand import Leinwand
from moebel import Moebel
class Schrankwand(Moebel):
    """
    Stellt eine  Schrankwand mit drei Schränken im Möbelplaner dar.
    Version mit reiner Codeduplizierung.
    """
    def __init__(self,xPosition=350,yPosition=30,randfarbe='black'):
        """
        Erzeugt eine Schrankwand an der gegebenen Position.
        xPosition: die x-Koordinate der Mitte der Schrankwand
        yPosition: die y-Koordinate der Mitte der Schrankwand
        randfarbe: die Randfarbe, in der der Schrank angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        super().__init__(xPosition,yPosition,180,40,randfarbe)

    def erzeugeFigur(self):
        """
        Erzeugt die Figur.
        """
        if not self.gibFormen():
            x,y,b,t,lw = self.gibX(),self.gibY(),\
                         self.gibB()/3,\
                         self.gibT(),self.gibLW()
            formen = []
            ## erster Schrank
            umriss1 = lw.polygon(x,y, x+b,y, x+b,y+t, x,y+t)
            formen.append(umriss1)
            lo_ru1 = lw.linie(x,y,x+b,y+t)
            formen.append(lo_ru1)
            ro_lu1 = lw.linie(x+b,y,x,y+t)
            formen.append(ro_lu1)
            ## zweiter Schrank
            x+=b
            umriss2 = lw.polygon(x,y, x+b,y, x+b,y+t, x,y+t)
            formen.append(umriss2)
            lo_ru2 = lw.linie(x,y,x+b,y+t)
            formen.append(lo_ru2)
            ro_lu2 = lw.linie(x+b,y,x,y+t)
            formen.append(ro_lu2)
            ## dritter Schrank
            x+=b
            umriss3 = lw.polygon(x,y, x+b,y, x+b,y+t, x,y+t)
            formen.append(umriss3)
            lo_ru3 = lw.linie(x,y,x+b,y+t)
            formen.append(lo_ru3)
            ro_lu3 = lw.linie(x+b,y,x,y+t)
            formen.append(ro_lu3)
            
            return formen

