## schrankwand.py
"""zweite Version: holt Figur von Schrankobjekten"""
from leinwand import Leinwand
from moebel import Moebel
from schrank import Schrank
class Schrankwand(Moebel):
    """
    Stellt eine  Schrankwand mit drei Schränken im Möbelplaner dar.
    Version mit Verwendungsbeziehung bei statischer Anzahl
    """
    def __init__(self,xPosition=350,yPosition=30,breite=180,tiefe=37,winkel=0,randfarbe='black'):
        """
        Erzeugt eine Schrankwand an der gegebenen Position.
        xPosition: die x-Koordinate der Mitte der Schrankwand
        yPosition: die y-Koordinate der Mitte der Schrankwand
        randfarbe: die Randfarbe, in der der Schrank angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        super().__init__(xPosition,yPosition,breite,tiefe,winkel,randfarbe)
        self.__schrank1 = Schrank(0, 0, breite/3, tiefe, 0, randfarbe)
        self.__schrank2 = Schrank(breite/3, 0, breite/3, tiefe, 0, randfarbe)
        self.__schrank3 = Schrank(2*breite/3, 0, breite/3, tiefe, 0, randfarbe)

    def erzeugeFigur(self):
        """
        Erzeugt die Figur.
        """
        x,y,b,t,w,lw = self.gibX(),self.gibY(),self.gibB(),self.gibT(),self.gibW(),self.gibLW()
        xm,ym=x+b/2,y+t/2
        if not self.gibFormen():
            formen = []
            ## erster Schrank
            formen+=self.__schrank1.erzeugeFigur()
            ## zweiter Schrank
            formen+=self.__schrank2.erzeugeFigur()
            ## dritter Schrank
            formen+=self.__schrank3.erzeugeFigur()
            for form in formen:
                lw.bewegen(form,x,y)
            return formen

