## schrankwand.py
"""dritte Version: V2 erweitert um flexible Zahl von Schrankobjekten"""
from leinwand import Leinwand
from moebel import Moebel
from schrank import Schrank
class Schrankwand(Moebel):
    """
    Stellt eine  Schrankwand mit drei Schränken im Möbelplaner dar.
    Version mit Verwendungsbeziehung bei flexibler Anzahl
    """
    def __init__(self,anzahl,xPosition=50,yPosition=50,schrankbreite=60,tiefe=37,winkel=0,randfarbe='black'):
        """
        Erzeugt eine Schrankwand an der gegebenen Position.
        xPosition: die x-Koordinate der Mitte der Schrankwand
        yPosition: die y-Koordinate der Mitte der Schrankwand
        randfarbe: die Randfarbe, in der der Schrank angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        breite=anzahl*schrankbreite
        super().__init__(xPosition,yPosition,
                         breite,tiefe,winkel,randfarbe)
        self.__schraenke=[]
        for i in range(anzahl):
            self.__schraenke.append(Schrank(i*breite/3, 0,breite/3,tiefe, 0, randfarbe))

    def erzeugeFigur(self):
        """
        Erzeugt die Figur.
        """
        x,y,b,t,w,lw = self.gibX(),self.gibY(),self.gibB(),self.gibT(),self.gibW(),self.gibLW()
        xm,ym=x+b/2,y+t/2
        formen=[]
        if not self.gibFormen():
            for schrank in self.__schraenke:
                formen+=schrank.erzeugeFigur()
            for form in formen:
                lw.bewegen(form,x,y)
            return formen

