## schrankwand.py
"""vierte Version: V2 erweitert um flexible Zahl von Schrankobjekten
mit den Methoden fuegeHinzu() und entferne()"""
from leinwand import Leinwand
from moebel import Moebel
from schrank import Schrank
class Schrankwand(Moebel):
    """
    Stellt eine  Schrankwand mit drei Schränken im Möbelplaner dar.
    Version mit Verwendungsbeziehung bei flexibler Anzahl
    """
    def __init__(self,
                 xPosition=50,
                 yPosition=50,
                 winkel=0,
                 randfarbe='black'):
        """
        Erzeugt eine Schrankwand an der gegebenen Position.
        xPosition: die x-Koordinate der Mitte der Schrankwand
        yPosition: die y-Koordinate der Mitte der Schrankwand
        randfarbe: die Randfarbe, in der der Schrank angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        super().__init__(xPosition,yPosition,0,0,winkel,randfarbe)
        self.__schraenke=[]

    def erzeugeFigur(self):
        """
        Erzeugt die Figur.
        """
        x,y,b,t,w,lw = self.gibX(),self.gibY(),self.gibB(),self.gibT(),self.gibW(),self.gibLW()
        xm,ym=x+b/2,y+t/2
        formen=[]
        if not self.gibFormen():
            for schrank in self.__schraenke:
                formen+=schrank.erzeugeFigur()
            for form in formen:
                lw.bewegen(form,x,y)
            return formen

    def fuegeHinzu(self, schrank):
        '''fuegt einen Schrank am Ende der Liste hinzu,
        raeumlich aber nicht positionsgerecht'''
        if schrank in self.__schraenke: return
        self.verberge()
        self.__schraenke.append(schrank)
        self.zeige()
    
    def entferne(self, schrank):
        '''entfernt das uebergebene Schrankobjekt'''
        if not(schrank in self.__schraenke): return
        self.verberge()
        self.__schraenke.remove(schrank)
        self.zeige()

#### sinnvolle Ergaenzung
##    def gibSchrank(self, position):
##        '''gibt das Schrankobjekt an der Position der Liste zurueck
##        Position 1 bis laenge'''
##        if position<=0: return None
##        if position>len(self.__schraenke): return None
##        return self.__schraenke[position-1]
